<template>
  <crud-data-table
    :items="periods"
    :headers="headers"
    :loading="isLoading"
    :search-placeholder="$t('global.crudDataTable.action.searchByTitlePlaceholder')"
    :no-data-message="$t('noDataText')"
  >
    <template v-slot:create>
      <create-period-dialog />
    </template>

    <template v-slot:confirmationToDelete>
      <delete-period-dialog @onDeletePeriod="onDeletePeriodCallback = $event" />
    </template>

    <template v-slot:title="props">
      <edit-title-dialog
        v-model="props.item.title"
        :item-id="props.item.id"
      />
    </template>

    <template v-slot:startDate="props">
      <edit-start-date-dialog
        v-model="props.item.startDate"
        :item-id="props.item.id"
        :end-date="props.item.endDate"
      />
    </template>

    <template v-slot:endDate="props">
      <edit-end-date-dialog
        v-model="props.item.endDate"
        :item-id="props.item.id"
        :start-date="props.item.startDate"
      />
    </template>

    <template v-slot:isDefault="props">
      <edit-is-default-dialog
        v-model="props.item.isDefault"
        :item-id="props.item.id"
      />
    </template>

    <template v-slot:isToDisplay="props">
      <edit-is-to-display-dialog
        v-model="props.item.isToDisplay"
        :item-id="props.item.id"
      />
    </template>

    <template v-slot:createdAt="{ item: { createdAt } }">
      {{ createdAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:updatedAt="{ item: { updatedAt } }">
      {{ updatedAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:delete="{ item }">
      <v-btn
        icon
        @click="onDeletePeriodCallback(item)"
      >
        <v-icon>
          mdi-trash-can-outline
        </v-icon>
      </v-btn>
    </template>
  </crud-data-table>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import getTableHeaders from './table-headers'
  import { get } from 'vuex-pathify'
  // components
  import EditTitleDialog from './components/crud/UpdateTitle.vue'
  import EditIsDefaultDialog from './components/crud/UpdateIsDefault'
  import EditIsToDisplayDialog from './components/crud/UpdateIsToDisplay'
  import EditStartDateDialog from './components/crud/UpdateStartDate'
  import EditEndDateDialog from './components/crud/UpdateEndDate'
  import DeletePeriodDialog from './components/crud/Delete.vue'
  import CreatePeriodDialog from './components/crud/Create.vue'

  export default {
    name: 'PeriodsView',
    components: {
      EditTitleDialog,
      EditIsDefaultDialog,
      EditIsToDisplayDialog,
      EditStartDateDialog,
      EditEndDateDialog,
      DeletePeriodDialog,
      CreatePeriodDialog,
    },
    mixins: [DatesMixin],
    data () {
      return {
        search: '',
        onDeletePeriodCallback: null,
        headers: getTableHeaders(key => this.$t(key)),
      }
    },
    computed: {
      ...get('periods', [
        'periods',
        'isLoading',
      ]),
    },
    i18n: {
      messages: {
        'pt-BR': {
          noDataText: 'Nenhum período cadastrado.',
        },
        'en-US': {
          noDataText: 'No period registered.',
        },
      },
    },
  }
</script>
